﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using System.Drawing;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace CAS_116109_Q3X8H3
{
    // Implements the CreationFilter interface		
    public class GridCreationFilter : IUIElementCreationFilter
    {                
        public GridCreationFilter()
        {
        }


        public bool BeforeCreateChildElements(Infragistics.Win.UIElement parent)  // Implements Infragistics.Win.IUIElementCreationFilter.BeforeCreateChildElements
        {
            // Don't need to do anything here
            return false;
        }

        public void AfterCreateChildElements(Infragistics.Win.UIElement parent) // Implements Infragistics.Win.IUIElementCreationFilter.AfterCreateChildElements
        {
            if (parent is GroupByRowDescriptionUIElement)  //Check for the GroupByRowDescriptionUIElement
            {
                DependentTextUIElement aDependentTextUIElement = (DependentTextUIElement)parent.GetDescendant(typeof(DependentTextUIElement));
                CheckBoxUIElement aCheckBoxUIElement;
                                
                if (aDependentTextUIElement == null) return;

                //Create a New CheckBoxUIElement
                aCheckBoxUIElement = new CheckBoxUIElement(parent);

                UltraGridGroupByRow aGroupByRow = (UltraGridGroupByRow)aCheckBoxUIElement.GetAncestor(typeof(GroupByRowUIElement)).GetContext(typeof(UltraGridGroupByRow));

                if (aGroupByRow.Tag == null)
                    aGroupByRow.Tag = CheckState.Unchecked;
                else
                    aCheckBoxUIElement.CheckState = (CheckState)aGroupByRow.Tag;
                
                parent.ChildElements.Add(aCheckBoxUIElement);
                aCheckBoxUIElement.Rect = new Rectangle(parent.Rect.X + 3, parent.Rect.Y, parent.Rect.Height, parent.Rect.Height);
                aDependentTextUIElement.Rect = new Rectangle(aCheckBoxUIElement.Rect.Right + 3, aDependentTextUIElement.Rect.Y, parent.Rect.Width - aCheckBoxUIElement.Rect.Right, aDependentTextUIElement.Rect.Height);
            }
            else if (parent is PreRowAreaUIElement)  //Check for the PreRowAreaUIElement
            {
                RowCellAreaUIElement rowCellAreaUIElement = (RowCellAreaUIElement)parent.Parent.GetDescendant(typeof(RowCellAreaUIElement));
                CheckBoxUIElement aCheckBoxUIElement;

                if (rowCellAreaUIElement == null) return;

                //Create a New CheckBoxUIElement
                aCheckBoxUIElement = new CheckBoxUIElement(parent);

                UltraGridRow aRow = (UltraGridRow)aCheckBoxUIElement.GetAncestor(typeof(RowUIElement)).GetContext(typeof(UltraGridRow));

                if (aRow.Tag == null)
                    aRow.Tag = CheckState.Unchecked;
                else
                    aCheckBoxUIElement.CheckState = (CheckState)aRow.Tag;
                
                parent.ChildElements.Add(aCheckBoxUIElement);
                aCheckBoxUIElement.Rect = new Rectangle(parent.Rect.X + 10, parent.Rect.Y, parent.Rect.Height, parent.Rect.Height);
                //Push the DependentTextUIElement to the right a little to make 
                //room for the CheckBox. 3 pixels of padding are used again. 
                //rowCellAreaUIElement.Rect = new Rectangle(aCheckBoxUIElement.Rect.Right + 5, rowCellAreaUIElement.Rect.Y, parent.Parent.Rect.Width - aCheckBoxUIElement.Rect.Right-5, rowCellAreaUIElement.Rect.Height);
                //new Rectangle(aCheckBoxUIElement.Rect.Right + 5, rowCellAreaUIElement.Rect.Y, parent.Rect.Width - aCheckBoxUIElement.Rect.Right, rowCellAreaUIElement.Rect.Height);
                /*Rectangle rect = parent.Rect;
                rect.Width = aCheckBoxUIElement.Rect.Width + 10;
                parent.Rect = rect;

                Rectangle rect2 = rowCellAreaUIElement.Rect;
                rect2.X = rect.Width;
                rowCellAreaUIElement.Rect = rect2;*/
            }
        }
    }

}
